/***************************************************************************
 *            engine.c
 *  
 *  Sat Feb 21 22:27:09 2004
 *  Copyright (C) 2004  Marcin Krzywonos
 *  e-mail: mkk@gnutu.org
 ****************************************************************************/

 /*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 
#include <ctype.h>
#include "engine.h"
#include "interface.h"


// Wczytuje baze danych z wpisami
int wczytaj_baze ()
{
	// Plik z baza danych
	char  tmp [300];
	sprintf (tmp, "%s/dane.gtu", katalog_ustawien);
	
	// Otwieramy plik
	FILE *plik = fopen (tmp, "r");

	// Jezeli nie udalo sie otworzyc pliku to tworzymy katalog ustawien
	if (plik == NULL) {
		system ("mkdir ~/.gnutu");
	} else {
		int i = 0;
		while (i != 2201) {
			i++;
			
			fread (&baza[i], sizeof (baza[i]), 1, plik); // zapisujemy rekordy
			
			if (baza[i].data.dzien == 0) // jezeli rekord jest pusty to konczymy
				break;
		}
		
		fclose (plik); // zamykamy plik
	}
}


// Zapisuje baze danych z wpisami
int zapisz_baze ()
{
	// nazwa pliku bazy danych
	char  tmp [300];
	//sprintf (tmp, "%s/dane.gtu", katalog_ustawien);
	sprintf (tmp, "%s/dane.gtu", katalog_ustawien);
	
	// otwieramy plik
	FILE *plik = fopen (tmp, "w");
	
	// Jezeli nie udalo sie otworzyc pliku to komunikat o bledzie
	if (plik == NULL) {
		komunikat (_("BLAD: Nie mozna zapisac pliku bazy danych (dane.gtu) !\n"));
	} else {
		ostatni = sprawdz_ostatni ();
		
		// Zapisujemy baze danych
		int i = 0;
		while (i != ostatni) {
			i++;
			
			fwrite (&baza[i], sizeof (baza[i]), 1, plik);  // zapisujemy rekord
		}
		
		fclose (plik); // zamykamy plik
	}
}


// Wyszukuje wpis w bazie danch wg. podanej daty
int szukaj_wpis (typ_data data)
{
	int i = 0;
	while (i != 2201) {
		i++;
		
		if (baza[i].data.dzien == 0) { // jezeli wpis jest pusty to konczymy
			return 0;
		} else {
			// sprawdza czy przegladany rekord jest taki sam jak szukany
			if ((baza[i].data.dzien == data.dzien) & (baza[i].data.miesiac == data.miesiac) & (baza[i].data.rok == data.rok)) {
				return i; // jesli tak to zwracamy jego numer
			} else {
				if (i == 2201) // jesli nie to konczymy
					return 0;
			}
		}
	}
}


// Zwraca numer ostatniego wpisu w bazie danych
int sprawdz_ostatni ()
{
	int i = 0;
	while (i != 2201) {
		i++;
	
		if (baza[i].data.dzien == 0) { // jezeli rekord jest pusty to konczymy
			i--;
			return i; // ... i zwracamy numer poprzednika
		}
	}
}


// Edytuje wpis o dacie...
int edytuj_wpis (typ_data data, wpis_struct wpis, gboolean zapisz_poprzedni)
{
	int numer;
	
	// Zapis starego wpisu...
	if (zapisz_poprzedni == TRUE) {
		if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
			baza[numer] = wpis;
			
			if (char_to_gboolean (ustawienia[0]) == TRUE)
				zapisz_baze ();
		} else {
			ostatni++;
			baza[ostatni] = wpis;
			
			if (char_to_gboolean (ustawienia[0]) == TRUE)
				zapisz_baze ();
		}
	} else {
		ostatni = sprawdz_ostatni ();
	}
	
	// Wczytywanie starego wpisu, lub tworzenie nowego...
	if ((numer = szukaj_wpis (data)) >= 1) {
		wypelnij_pola (baza[numer]);
		pobierz_biezaca_date ();
		
		wpisz_biezaca_date ();
	} else {
		wypelnij_pola (czysty_wpis ());
		pobierz_biezaca_date ();
		
		if (char_to_gboolean (ustawienia[1]) == TRUE) {
			if (sprawdz_dzien_wolny (biezaca_data) == TRUE) {
			} else {
				laduj_przedmioty ();
			}
		}
	}
	
	// Wyswietlenie najblizszego sprawdzianu
	wyswietl_najblizszy_sprawdzian ();
	wyswietl_licznik ();
}


// Zwraca czysty wpis
wpis_struct czysty_wpis ()
{
	wpis_struct tmp;
	
	strcpy (tmp.sprawdzian,   "");
	strcpy (tmp.kartkowka1,   "");
	strcpy (tmp.kartkowka2,   "");
	strcpy (tmp.notatki,      "");
	strcpy (tmp.przedmiot[1], "");
	strcpy (tmp.przedmiot[2], "");
	strcpy (tmp.przedmiot[3], "");
	strcpy (tmp.przedmiot[4], "");
	strcpy (tmp.przedmiot[5], "");
	strcpy (tmp.przedmiot[6], "");
	strcpy (tmp.przedmiot[7], "");
	strcpy (tmp.przedmiot[8], "");
	strcpy (tmp.oceny[1],     "");
	strcpy (tmp.oceny[2],     "");
	strcpy (tmp.oceny[3],     "");
	strcpy (tmp.oceny[4],     "");
	strcpy (tmp.oceny[5],     "");
	strcpy (tmp.oceny[6],     "");
	strcpy (tmp.oceny[7],     "");
	strcpy (tmp.oceny[8],     "");

	return tmp;
}


// Wczytuje przedmioty z planu lekcji
int laduj_przedmioty ()
{
	int numer_dnia = dzien_tygodnia (biezaca_data);
	numer_dnia--;
	
	if ((numer_dnia >= 0) & (numer_dnia <= 4)) {
		wstaw_przedmioty (numer_dnia);
	}
}


// Wyszujuje najblizsze sprawdziany
int szukaj_sprawdzianow ()
{
	int       i  = 0;
	int       lk = 0;
	char     *spr [3];
	typ_data  daty_spr [3];
	
	while (i != ostatni) {
		i++;
		
		if ((baza[i].data.rok == biezaca_data.rok) &
			(baza[i].data.miesiac <= (biezaca_data.miesiac + 1)) & 
			(baza[i].data.miesiac >= biezaca_data.miesiac) &
			(strlen (baza[i].sprawdzian) >= 2)) {			
			
			if ((baza[i].data.miesiac == biezaca_data.miesiac) &
				(baza[i].data.dzien < biezaca_data.dzien)) {
			} else {
				lk++;
				
				spr[lk]      = baza[i].sprawdzian;
				daty_spr[lk] = baza[i].data;
				
				if (lk == 3) {
					break;
				}

			}
		}
	}

	char tekst[255];
	
	switch (lk) {
		case 1: sprintf (tekst, _("Znalezione sprawdziany:\n%d-%d-%d: %s"),
						daty_spr[1].dzien, (daty_spr[1].miesiac + 1), daty_spr[1].rok, spr[1]);
				break;
		case 2: sprintf (tekst, _("Znalezione sprawdziany:\n%d-%d-%d: %s\n%d-%d-%d: %s"),
						daty_spr[1].dzien, (daty_spr[1].miesiac + 1), daty_spr[1].rok, spr[1],
						daty_spr[2].dzien, (daty_spr[2].miesiac + 1), daty_spr[2].rok, spr[2]);
				break;
		case 3: sprintf (tekst, _("Znalezione sprawdziany:\n%d-%d-%d: %s\n%d-%d-%d: %s\n%d-%d-%d: %s"),
						daty_spr[1].dzien, (daty_spr[1].miesiac + 1), daty_spr[1].rok, spr[1],
						daty_spr[2].dzien, (daty_spr[2].miesiac + 1), daty_spr[2].rok, spr[2],
						daty_spr[3].dzien, (daty_spr[3].miesiac + 1), daty_spr[3].rok, spr[3]);
				break;
		case 0: sprintf (tekst, _("Nie znaleziono sprawdzianow !"));
				break;
	}

	komunikat (tekst);
}


// Funkcja zwraca liste ocen do 1 parametru (lista)
void zestawienie_ocen (lista_ocen lista [30], typ_data poczatek, typ_data koniec)
{
	int i = 0;
	int j = 1;
	
	while (i != 30) {
		strcpy (lista[i].przedmiot, "");
		strcpy (lista[i].oceny,     "");
		
		i++;
	}
	
	i = -1;
	
	while (i != 2201) {
		i++;
		
		// sprawdzamy czy rok sie zgadza...
		if ((baza[i].data.rok >= poczatek.rok) & (baza[i].data.rok <= koniec.rok)) {
			// sprawdzamy czy miesiac sie zgadza
			if ((baza[i].data.rok == koniec.rok) & (baza[i].data.miesiac > koniec.miesiac))
				continue;
			
			if ((baza[i].data.rok == poczatek.rok) & (baza[i].data.miesiac < poczatek.miesiac))
				continue;
			
			// sprawdzamy czy dzien sie zgadza
			if ((baza[i].data.rok == koniec.rok) & (baza[i].data.miesiac == koniec.miesiac) & (baza[i].data.dzien > koniec.dzien))
				continue;
			
			if ((baza[i].data.rok == poczatek.rok) & (baza[i].data.miesiac == poczatek.miesiac) & (baza[i].data.dzien < poczatek.dzien))
				continue;
			
			// wszystko w porzadku - zbieramy informacje...
			j = 1;
			while (j <= 8) {
				if (strlen (baza[i].przedmiot [j]) > 0)
					dopisz_oceny (lista, baza[i].przedmiot[j], baza[i].oceny[j]);
				
				j++;
			}
		}
	}
}


// Wyswietla najblizszy sprawdzian
void wyswietl_najblizszy_sprawdzian ()
{
	if (char_to_gboolean (ustawienia[2]) == FALSE) {
		char tekst [150];
		sprintf (tekst, "");
		uaktualnij_sprawdzian (tekst);
		
		return 0;
	}
	
	int       i  = 0;
	char     *spr;
	typ_data  data;
	
	if (ostatni == 0) {
		char tekst [150];
		sprintf (tekst, _("<b>Najblizszy sprawdzian</b>\nbrak"));
		uaktualnij_sprawdzian (tekst);
		
		return 0;
	}
	
	while (i != ostatni) {
		i++;
		
		if ((baza[i].data.rok == biezaca_data.rok) &
			(baza[i].data.miesiac <= (biezaca_data.miesiac + 1)) & 
			(baza[i].data.miesiac >= biezaca_data.miesiac) &
			(strlen (baza[i].sprawdzian) >= 2)) {
			
			if ((baza[i].data.miesiac == biezaca_data.miesiac) &
				(baza[i].data.dzien < biezaca_data.dzien)) {
				
				char tekst [150];
				sprintf (tekst, _("<b>Najblizszy sprawdzian</b>\nbrak"));
				uaktualnij_sprawdzian (tekst);
				
				break;
			} else {
				spr  = baza[i].sprawdzian;
				data = baza[i].data;
				char tekst [150];
				
				if ((baza[i].data.rok == biezaca_data.rok) &
					(baza[i].data.miesiac == biezaca_data.miesiac) &
					((baza[i].data.dzien - biezaca_data.dzien) <= 7)) {
					sprintf (tekst, _("<b>Najblizszy sprawdzian\n[%d-%d-%d] %s</b>\n"), data.dzien, (data.miesiac + 1), data.rok, spr);
				} else {
					sprintf (tekst, _("<b>Najblizszy sprawdzian</b>\n[%d-%d-%d] %s\n"), data.dzien, (data.miesiac + 1), data.rok, spr);
				}
				uaktualnij_sprawdzian (tekst);
				
				break;
			}
		} else {
			char tekst [150];
			sprintf (tekst, _("<b>Najblizszy sprawdzian</b>\nbrak"));
			uaktualnij_sprawdzian (tekst);
		}
	}
}

// Wyswietla ilosc dni do konca wakacji, lub konca roku szkolnego
void wyswietl_licznik ()
{
	if ((strlen (ustawienia [3]) < 3) | (strlen (ustawienia [4]) < 3)) {
		strcpy (ustawienia[3], "25-06");
		strcpy (ustawienia[4], "1-09");
		ustawienia_domyslne ();
	}
	
	char tmp[100];
	
	typ_data poczatek, koniec, data;
	sscanf (ustawienia[3], "%d-%d", &poczatek.dzien, &poczatek.miesiac);
	sscanf (ustawienia[4], "%d-%d", &koniec.dzien, &koniec.miesiac);
	poczatek.miesiac--;
	koniec.miesiac--;
	
	int ilosc = 0;
	
	poczatek.rok = biezaca_data.rok;
	koniec.rok   = biezaca_data.rok;
	
	int miesiac_struct []   = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	
	if (sprawdz_czy_wakacje (biezaca_data) == TRUE) { // Funkcja podaje czy mamy wakacje
		if (biezaca_data.miesiac == koniec.miesiac) {
			ilosc += (koniec.dzien - biezaca_data.dzien);
		} else {
			int i = 0;
			
			while (i < (koniec.miesiac - biezaca_data.miesiac)) {
				i++;
				ilosc += miesiac_struct [(biezaca_data.miesiac + i)];
			}
			
			if (biezaca_data.miesiac == poczatek.miesiac) {
				ilosc -= (biezaca_data.dzien + 1);
			} else {
				ilosc -= biezaca_data.dzien;
			}
			
			ilosc += koniec.dzien;
			ilosc += 1;
		}
			
		sprintf (tmp, _("<b>Do konca wakacji pozostalo dni: </b>%d"), ilosc);
	} else {
		typ_data tmp_data = biezaca_data;
		
		if (tmp_data.miesiac == poczatek.miesiac) {
			ilosc += (poczatek.dzien - tmp_data.dzien);
		} else {
			tmp_data.miesiac++;
			
			while (tmp_data.miesiac != poczatek.miesiac) {
				if (tmp_data.miesiac > 11)
					tmp_data.miesiac = 0;
				
				ilosc += miesiac_struct [tmp_data.miesiac];
				
				tmp_data.miesiac++;
			}
			
			ilosc += (miesiac_struct [biezaca_data.miesiac] - biezaca_data.dzien);
			
			ilosc += poczatek.dzien;
		}
		
		sprintf (tmp, _("<b>Do konca roku szkolnego pozostalo dni: </b>%d"), ilosc);
	}
	
	uaktualnij_licznik (tmp);
}


// Cofa ostatnia modyfikacje
void cofnij_modyfikacje ()
{
	int numer;
	
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		wypelnij_pola (baza[numer]);
		pobierz_biezaca_date ();
		
		wpisz_biezaca_date ();
	} else {
		wypelnij_pola (czysty_wpis ());
		pobierz_biezaca_date ();
		
		if (sprawdz_dzien_wolny (biezaca_data) == TRUE) {
		} else {
			laduj_przedmioty ();
		}
		
		wpisz_biezaca_date ();
	}
	
	// Wyswietlenie najblizszego sprawdzianu
	wyswietl_najblizszy_sprawdzian ();
	wyswietl_licznik ();
}


// Zapisuje baze wolne dni
int zapisz_wolne_dni ()
{
	char  tmp [300];
	
	sprintf (tmp, "%s/wolne_dni.gtu", katalog_ustawien);
	
	FILE *plik = fopen (tmp, "w");
	
	if (plik == NULL) {
		komunikat (_("BLAD: Nie mozna utworzyc pliku bazy wolnych dni (wolne_dni.gtu) !\n"));
	} else {
		int i = 0;
		
		while (i != 365) {
			if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0)) {
				break;
			} else {
				if ((wolne_dni[i].dzien != 100) & (wolne_dni[i].miesiac != 100) & (wolne_dni[i].rok != 1000)) {
					fwrite (&wolne_dni[i], sizeof (wolne_dni[i]), 1, plik);
				}
			}
			
			i++;
		}
		
		fclose (plik);
	}
	
	wczytaj_wolne_dni ();
}


// Wczytuje baze wolnych dni
int wczytaj_wolne_dni ()
{
	char  tmp [300];
	
	sprintf (tmp, "%s/wolne_dni.gtu", katalog_ustawien);
	
	FILE *plik = fopen (tmp, "r");
	
	if (plik != NULL) {
		int i = 0;
		
		while (i != 365) {
			fread (&wolne_dni[i], sizeof (wolne_dni[i]), 1, plik);
			
			if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0)) {
				break;
			} else {
			}
			
			i++;
		}
		
		fclose (plik);
	}
}


// Dodaje pozycje do bazy wolnych dni
int wolne_dni_dodaj (typ_data data)
{
	int i = 0;
	while (i != 365) {
		if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0))
			break;
		
		if ((wolne_dni[i].dzien == 100) & (wolne_dni[i].miesiac == 100) & (wolne_dni[i].rok == 10000)) {
			break;
		}
		
		i++;
	}
	
	wolne_dni[i] = data;
}


// Usuwa pozycje w bazie wolnych dni
int wolne_dni_usun (typ_data data)
{
	int i = 0;
	while (i != 365) {
		if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0))
			break;
		
		if ((wolne_dni[i].dzien == data.dzien) & (wolne_dni[i].miesiac == data.miesiac) &
			(wolne_dni[i].rok == data.rok)) {
			wolne_dni[i].dzien   = 100;
			wolne_dni[i].miesiac = 100;
			wolne_dni[i].rok     = 10000;
			break;
		}
		
		i++;
	}
	i++;
}


// Sprawdza czy dzien (data) istnieje w bazie wolne dni
gboolean wolne_dni_istnieje (typ_data data)
{
	int i = 0;
	while (i != 365) {
		if ((wolne_dni[i].dzien == 100) & (wolne_dni[i].miesiac == 100) & (wolne_dni[i].rok == 10000)) {
			return FALSE;
		}
		
		if ((wolne_dni[i].dzien == data.dzien) & (wolne_dni[i].miesiac == data.miesiac) &
			(wolne_dni[i].rok == data.rok)) {
			return TRUE;
		}
		
		i++;
	}
	
	return FALSE;
}


// Sprawdza, czy dzien jest dniem wolnym
gboolean sprawdz_dzien_wolny (typ_data data)
{
	// Sprawdzanie wakacji
	if (sprawdz_czy_wakacje (data) == TRUE)
		return TRUE;
	
	
	// Sprawdzanie wg. dni wolnych
	int i = 0;
	
	data.miesiac++;
	
	while (i != 365) {
		if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0)) {
			return FALSE;
		} else {
			if ((wolne_dni[i].dzien != 100) & (wolne_dni[i].miesiac != 100) & (wolne_dni[i].rok != 1000)) {
				if ((wolne_dni[i].dzien == data.dzien) & (wolne_dni[i].miesiac == data.miesiac) & (wolne_dni[i].rok == data.rok)) {
					return TRUE;
				}
			}
		}
		
		i++;
	}
	
	return FALSE;
}


// funkcja sprawdza czy dany dzien to wakacje
gboolean sprawdz_czy_wakacje (typ_data data)
{
	typ_data wakacje_poczatek, wakacje_koniec;
	sscanf (ustawienia[3], "%d-%d", &wakacje_poczatek.dzien, &wakacje_poczatek.miesiac);
	sscanf (ustawienia[4], "%d-%d", &wakacje_koniec.dzien, &wakacje_koniec.miesiac);
	
	wakacje_poczatek.miesiac--;
	wakacje_koniec.miesiac--;
	
	if ((data.miesiac >= wakacje_poczatek.miesiac) & (data.miesiac <= wakacje_koniec.miesiac)) {
		if (((data.miesiac == wakacje_poczatek.miesiac) & (data.dzien < wakacje_poczatek.dzien)) |
		   ((data.miesiac == wakacje_koniec.miesiac) & (data.dzien > wakacje_koniec.dzien))) {
			return FALSE;
		} else {
			return TRUE;
		}
	} else {
		return FALSE;
	}
}


// Zapisuje baze planu lekcji
int zapisz_plan_lekcji ()
{
	char  tmp [300];
	
	sprintf (tmp, "%s/plan.gtu", katalog_ustawien);
	
	FILE *plik;
	
	if ((plik = fopen (tmp, "w")) == NULL) {
		komunikat (_("BLAD: Nie mozna utworzyc pliku planu lekcji (plan.gtu) !\n"));
	} else {
		fwrite (&plan, sizeof (plan), 1, plik);
		fclose (plik);
	}
}


// Wczytuje baze planu lekcji
int wczytaj_plan_lekcji ()
{
	char  tmp [300];
	
	sprintf (tmp, "%s/plan.gtu", katalog_ustawien);
	
	FILE *plik = fopen (tmp, "r");
	
	if (plik != NULL) {
		fread (&plan, sizeof (plan), 1, plik);
		fclose (plik);
	}
}


// Oblicza dzien tygodnia (podana jest data)
int dzien_tygodnia (typ_data data)
{
	int miesiac_struct []   = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	data.miesiac ++;
	
	int roznica_dni  = 0;
	int licznik      = 0;

	if (data.rok > 2100) {
		komunikat (_("Pewny jestes, ze mamy rok wiekszy od 2100 ? :-)"));
	} else {
		while (licznik < (2102 - data.rok)) {
			licznik++;
			
			if (((2103 - licznik) % 4) == 0) {
				roznica_dni += 366;
			} else {
				roznica_dni += 365;
			}
		}
		
		licznik = data.miesiac;
		
		while (licznik < 12) {
			licznik++;
			if ((licznik == 2) & ((data.rok % 4) == 0)) {
				roznica_dni += (miesiac_struct [licznik] + 1);
			} else {
				roznica_dni += miesiac_struct [licznik];
			}
		}
		
		if ((data.miesiac == 2) & ((data.rok % 4) == 0)) {
			roznica_dni += ((miesiac_struct [data.miesiac] + 1) - data.dzien - 1);
		} else {
			roznica_dni += (miesiac_struct [data.miesiac] - data.dzien - 1);
		}
	}
	
	return (7 - (roznica_dni % 7));
}


// Dopisuje do listy oceny z danego przedmiotu
void dopisz_oceny (lista_ocen lista [30], char przedmiot [20], char oceny [20])
{
	int i = 0;
	int r = -1;
	
	while (i <= 30) {
		if (strlen (lista[i].przedmiot) < 1) {
			strcpy (lista[i].przedmiot, przedmiot);
			r = i;
			
			break;
		}
		
		if (strcmp (lista[i].przedmiot, przedmiot) == 0) {
			r = i;
			
			break;
		}
		
		i++;
	}
	
	char temp [512];
	oczysc_oceny (temp, oceny);
	
	if (r >= 0)
		strcat (lista[r].oceny, temp);
}


// Oczyszcza liste ocen z nienumerycznych znakow
void oczysc_oceny (char oczyszczone[512], char oceny[512])
{
	int i = 0;
	strcpy (oczyszczone, "");
	
	while (i <= strlen (oceny)) {
		if (isdigit (oceny[i]) > 0)
			sprintf (oczyszczone, "%s%c", oczyszczone, oceny[i]);
		
		i++;
	}
}


// Funkcja oblicza srednia ocen podanych w postaci tekstu
float oblicz_srednia (char oceny [100])
{
	if (strlen (oceny) == 0)
		return 0;
	
	int   i       = 0;
	int   ilosc   = 0;
	float srednia = 0;
	float tmp     = 0;
	
	while (i <= strlen (oceny)) {
		if (isdigit (oceny[i]) > 0) {
			ilosc++;
			srednia += ctoi (oceny[i]);
		}
		
		i++;
	}
	
	srednia /= ilosc;
	
	return srednia;
}
