/***************************************************************************
 *            wn.c
 *
 *  Fri Apr 16 13:56:50 2004
 *  Copyright (C) 2004  Marcin Krzywonos
 *  e-mail: mkk@akcja.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 
#include <dirent.h>

#include "var.h"
#include "wn.h"


// Zapisanie wpisu dziennika
void wn_zapisz_notatke ()
{
	// Wczytanie zawartosci widgetu edytora (wd_edytor) do zmiennej notatka
	char *notatka;
	GtkWidget *wd_edytor = lookup_widget (GTK_WIDGET (wd_widget), "wd_edytor");
	GtkTextIter start, end;
	GtkTextBuffer *text_buffer;
	text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wd_edytor));
	gtk_text_buffer_get_bounds (text_buffer, &start, &end);
	notatka = gtk_text_buffer_get_text (text_buffer, &start, &end, TRUE);
	
	// Proba zapisu wpisu dziennika
	char nazwa_pliku[100];
	sprintf (nazwa_pliku, "%s/dziennik/%d-%d-%d.gtu", katalog_ustawien, wn_edytowany_dzien.dzien, (wn_edytowany_dzien.miesiac + 1), wn_edytowany_dzien.rok);
	FILE *plik = fopen (nazwa_pliku, "w");
	
	// W przypadku niepowodzenia zostanie podjeta proba utworzenia
	// katalogu dziennika i ponownego otwarcia pliku
	if (plik == NULL) {
		system ("mkdir ~/.gnutu/dziennik");
		plik = fopen (nazwa_pliku, "w");
	}
	
	if (plik != NULL) {
		fputs (notatka, plik);
		fclose (plik);
	} else {
		// Jezeli nie udalo sie otworzyc pliku wyswietlamy komunikat bledu
		komunikat (_("BLAD: Nie mozna zapisac pliku dziennika (%s) !\n"), nazwa_pliku);
		return;
	}
	
	// Jezeli wpis jest pusty to zostaje on usuniety
	if (strlen (notatka) == 0)
		remove (nazwa_pliku);
}


// Wczytywanie pliku dziennika
void wn_wczytaj_notatke ()
{
	char  tekst[4096];      // Zmienna przechowuje pojedyncza linijke tekstu
	char  nazwa_pliku[100]; // Zmienna przechowuje nazwe pliku dziennika
	// Wygenerowanie nazwy pliku na podstawie daty edytowanego wpisu
	sprintf (nazwa_pliku, "%s/dziennik/%d-%d-%d.gtu", katalog_ustawien, wn_edytowany_dzien.dzien, (wn_edytowany_dzien.miesiac + 1), wn_edytowany_dzien.rok);
	
	GtkWidget *wd_edytor       = lookup_widget (GTK_WIDGET (wd_widget), "wd_edytor");
	GtkTextBuffer *text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wd_edytor));
	gtk_text_buffer_set_text (text_buffer, "", strlen (""));
		
	FILE *plik = fopen (nazwa_pliku, "r");

	// Jezeli plik zostal otwarty to wczytujemy go
	if (plik != NULL) {
		// Wczytujemy tekst
		while (!feof (plik)) {
			fgets (tekst, 8192, plik);
			gtk_text_buffer_insert_at_cursor (text_buffer, tekst, strlen (tekst));
		}
		
		fclose (plik);
	}
}


int wn_uaktualnij_liste ()
{
	GtkWidget *wn_lista = lookup_widget (GTK_WIDGET (wd_widget), "wn_lista");
	
	gtk_clist_freeze (GTK_CLIST (wn_lista));
	gtk_clist_clear (GTK_CLIST (wn_lista));
	
	char  tmp[255];
	DIR  *katalog;
	
	struct dirent *plik;
	
	sprintf (tmp, "%s/dziennik", katalog_ustawien);
	
	if (katalog = opendir (tmp)) {
		gchar *ins_str[1];
		char *tmp2;
		
		while (plik = readdir (katalog)) {
			if (plik->d_name[0] != '.') {
				ins_str[0] = strtok (plik->d_name, ".");
				gtk_clist_insert (GTK_CLIST (wn_lista), 0, ins_str);
			}
		}
		
		closedir (katalog);
	}
	
	gtk_clist_thaw (GTK_CLIST (wn_lista));
}
