/***************************************************************************
 *            wpref.c
 *
 *  Sat Mar 27 12:45:41 2004
 *  Copyright  2004  Marcin Krzywonos
 *  e-mail: mkk@akcja.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "wpref.h"
#include "engine.h"


int wp_wolne_dni_zaznaczony = 0;


void zapisz_ustawienia_glowne ()
{
	GtkWidget *wp_zapis_bazy               = lookup_widget (GTK_WIDGET (wp_widget), "wp_zapis_bazy");
	GtkWidget *wp_automatyczne_wstawianie  = lookup_widget (GTK_WIDGET (wp_widget), "wp_automatyczne_wstawianie");
	GtkWidget *wp_najblizsze_sprawdziany   = lookup_widget (GTK_WIDGET (wp_widget), "wp_najblizsze_sprawdziany");
	GtkWidget *wp_wakacje_poczatek_dzien   = lookup_widget (GTK_WIDGET (wp_widget), "wp_wakacje_poczatek_dzien");
	GtkWidget *wp_wakacje_poczatek_miesiac = lookup_widget (GTK_WIDGET (wp_widget), "wp_wakacje_poczatek_miesiac");
 	GtkWidget *wp_wakacje_koniec_dzien     = lookup_widget (GTK_WIDGET (wp_widget), "wp_wakacje_koniec_dzien");
	GtkWidget *wp_wakacje_koniec_miesiac   = lookup_widget (GTK_WIDGET (wp_widget), "wp_wakacje_koniec_miesiac");
	
	gboolean zapis_bazy              = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wp_zapis_bazy));
	gboolean automatyczne_wstawianie = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wp_automatyczne_wstawianie));
	gboolean najblizsze_sprawdziany  = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wp_najblizsze_sprawdziany));
	
	strcpy (ustawienia[0], gboolean_to_char (zapis_bazy));
	strcpy (ustawienia[1], gboolean_to_char (automatyczne_wstawianie));
	strcpy (ustawienia[2], gboolean_to_char (najblizsze_sprawdziany));
	
	char tmp_txt[6];
	
	sprintf (tmp_txt, "%d-%d", gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_wakacje_poczatek_dzien)), gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_wakacje_poczatek_miesiac)));
	strcpy (ustawienia[3], tmp_txt);
	
	sprintf (tmp_txt, "%d-%d", gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_wakacje_koniec_dzien)), gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_wakacje_koniec_miesiac)));
	strcpy (ustawienia[4], tmp_txt);
}


void wp_wolne_dni_dodaj_dzien_wolny ()
{
	int wartosc;
	typ_data tmp;
	
	GtkWidget *wp_dzien = lookup_widget (GTK_WIDGET (wp_widget), "wp_dzien");
	tmp.dzien = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_dzien));
	
	GtkWidget *wp_miesiac = lookup_widget (GTK_WIDGET (wp_widget), "wp_miesiac");
	tmp.miesiac = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_miesiac));
	
	GtkWidget *wp_rok = lookup_widget (GTK_WIDGET (wp_widget), "wp_rok");
	tmp.rok = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_rok));
	
	if (wolne_dni_istnieje (tmp) == FALSE) {
		GtkWidget *wp_wolne_dni = lookup_widget (GTK_WIDGET (wp_widget), "wp_wolne_dni");
	char tmp_str[10];
		sprintf (tmp_str, "%d-%d-%d", tmp.dzien, tmp.miesiac, tmp.rok);
		char *ins_str[] = {tmp_str};
		gtk_clist_insert (GTK_CLIST (wp_wolne_dni), 0, ins_str);
		
		wolne_dni_dodaj (tmp);
	}
}


void wp_wolne_dni_usun_dzien_wolny ()
{
	GtkWidget *wp_wolne_dni = lookup_widget (GTK_WIDGET (wp_widget), "wp_wolne_dni");
	
	char     *tmp_str;
	typ_data  tmp_data;
	gtk_clist_get_text (GTK_CLIST (wp_wolne_dni), wp_wolne_dni_zaznaczony, 0, &tmp_str);
	sscanf (tmp_str, "%d-%d-%d", &tmp_data.dzien, &tmp_data.miesiac, &tmp_data.rok);
	
	gtk_clist_remove (GTK_CLIST (wp_wolne_dni), wp_wolne_dni_zaznaczony);
	wolne_dni_usun (tmp_data);
}


void wp_wolne_dni_wypelnij ()
{
	GtkWidget *wp_wolne_dni = lookup_widget (GTK_WIDGET (wp_widget), "wp_wolne_dni");
	
	gtk_clist_freeze (GTK_CLIST (wp_wolne_dni));
	gtk_clist_clear (GTK_CLIST (wp_wolne_dni));
	
	int   licznik = 0;
	char  tmp_str[10];
	char *ins_str;
	
	while (licznik != 255) {
		if ((wolne_dni[licznik].dzien != 0) & (wolne_dni[licznik].miesiac != 0) & (wolne_dni[licznik].rok != 0)) {
			if ((wolne_dni[licznik].dzien != 100) & (wolne_dni[licznik].miesiac != 100) & (wolne_dni[licznik].rok != 1000)) {
				sprintf (tmp_str, "%d-%d-%d", wolne_dni[licznik].dzien, wolne_dni[licznik].miesiac, wolne_dni[licznik].rok);
				ins_str = tmp_str;
				gtk_clist_insert (GTK_CLIST (wp_wolne_dni), 0, &ins_str);
			}
		} else {
			break;
		}
		
		licznik++;
	}
	
	gtk_clist_thaw (GTK_CLIST (wp_wolne_dni));
}


void wp_wczytaj_ustawienia ()
{
	GtkWidget *wp_zapis_bazy               = lookup_widget (GTK_WIDGET (wp_widget), "wp_zapis_bazy");
	GtkWidget *wp_automatyczne_wstawianie  = lookup_widget (GTK_WIDGET (wp_widget), "wp_automatyczne_wstawianie");
	GtkWidget *wp_najblizsze_sprawdziany   = lookup_widget (GTK_WIDGET (wp_widget), "wp_najblizsze_sprawdziany");
	GtkWidget *wp_wakacje_poczatek_dzien   = lookup_widget (GTK_WIDGET (wp_widget), "wp_wakacje_poczatek_dzien");
	GtkWidget *wp_wakacje_poczatek_miesiac = lookup_widget (GTK_WIDGET (wp_widget), "wp_wakacje_poczatek_miesiac");
 	GtkWidget *wp_wakacje_koniec_dzien     = lookup_widget (GTK_WIDGET (wp_widget), "wp_wakacje_koniec_dzien");
	GtkWidget *wp_wakacje_koniec_miesiac   = lookup_widget (GTK_WIDGET (wp_widget), "wp_wakacje_koniec_miesiac");
	
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wp_zapis_bazy), char_to_gboolean (ustawienia[0]));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wp_automatyczne_wstawianie), char_to_gboolean (ustawienia[1]));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wp_najblizsze_sprawdziany), char_to_gboolean (ustawienia[2]));
	
	int tmp1, tmp2;
	
	sscanf (ustawienia[3], "%d-%d", &tmp1, &tmp2);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (wp_wakacje_poczatek_dzien), tmp1);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (wp_wakacje_poczatek_miesiac), tmp2);
	
	sscanf (ustawienia[4], "%d-%d", &tmp1, &tmp2);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (wp_wakacje_koniec_dzien), tmp1);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (wp_wakacje_koniec_miesiac), tmp2);
}


void wp_zapisz_ustawiennia ()
{
	zapisz_wolne_dni         ();
	zapisz_ustawienia_glowne ();
	
	zapisz_ustawienia        ();
	wczytaj_ustawienia       ();
}


void wp_wolne_dni_zaznaczony_zmien (int numer)
{
	wp_wolne_dni_zaznaczony = numer;
}


void wczytaj_ustawienia ()
{
	FILE *plik;
	int   i = 0;
	char  tmp [300];
	
	sprintf (tmp, "%s/ustawienia.gtuconf", katalog_ustawien);
	
	while (i != 50) {
		strcpy (ustawienia[i], "");
		i++;
	}
	
	plik = fopen (tmp, "r");
	if (plik == NULL) {
		ustawienia_domyslne ();
	} else {
		fread (&ustawienia, sizeof (ustawienia), 1, plik);
		fclose (plik);
	}
}


void zapisz_ustawienia ()
{
	FILE *plik;
	char  tmp [300];
	
	sprintf (tmp, "%s/ustawienia.gtuconf", katalog_ustawien);
	
	if ((plik = fopen (tmp, "w")) == NULL) {
		komunikat (_("BLAD: Nie mozna otworzyc pliku ustawien (ustawienia.gtuconf) !\n"));
	} else {
		fwrite (&ustawienia, sizeof (ustawienia), 1, plik);
		fclose (plik);
	}
}


void ustawienia_domyslne ()
{
	strcpy (ustawienia[0], "TRUE");
	strcpy (ustawienia[1], "TRUE");
	strcpy (ustawienia[2], "TRUE");
	strcpy (ustawienia[3], "25-06");
	strcpy (ustawienia[4], "1-09");
}
