/***************************************************************************
 *            wzo.c
 *  
 *  Sat Feb 21 22:27:09 2004
 *  Copyright (C) 2004  Marcin Krzywonos
 *  e-mail: mkk@gnutu.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#include "wzo.h"
#include "engine.h"


void wzo_uzupelnij_liste_ocen ()
{
	wzo_ilosc_ocen [0] = 0;
	wzo_ilosc_ocen [1] = 0;
	wzo_ilosc_ocen [2] = 0;
	wzo_ilosc_ocen [3] = 0;
	wzo_ilosc_ocen [4] = 0;
	wzo_ilosc_ocen [5] = 0;
	
	GtkWidget *wzo_lista_ocen     = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_lista_ocen");
	GtkWidget *wzo_data_poczatek  = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_data_poczatek");
	GtkWidget *wzo_data_koniec    = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_data_koniec");
	GtkWidget *wzo_ilosc_1        = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_ilosc_1");
	GtkWidget *wzo_ilosc_2        = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_ilosc_2");
	GtkWidget *wzo_ilosc_3        = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_ilosc_3");
	GtkWidget *wzo_ilosc_4        = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_ilosc_4");
	GtkWidget *wzo_ilosc_5        = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_ilosc_5");
	GtkWidget *wzo_ilosc_6        = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_ilosc_6");
	GtkWidget *wzo_ilosc_wszystko = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_ilosc_wszystko");
	
	gtk_clist_freeze (GTK_CLIST (wzo_lista_ocen));
	gtk_clist_clear (GTK_CLIST (wzo_lista_ocen));
	
	lista_ocen lista [30];
	
	typ_data poczatek = data_rozkoduj (gnome_date_edit_get_time (GNOME_DATE_EDIT(wzo_data_poczatek)));
	typ_data koniec   = data_rozkoduj (gnome_date_edit_get_time (GNOME_DATE_EDIT(wzo_data_koniec)));
	poczatek.miesiac--;
	koniec.miesiac--;
	
	zestawienie_ocen (lista, poczatek, koniec);
	
	gchar *ins_str[3];
	int    i       = 0;
	float  srednia = 0;
	int    ilosc   = 0;
	float  s_tmp   = 0;
	char   tmp    [5];
	
	while (i != 30) {
		if (strlen (lista[i].przedmiot) < 1)
			break;
		
		s_tmp = oblicz_srednia (lista[i].oceny);
		sprintf (tmp, "%.2f", s_tmp);
		
		if (strlen (lista[i].oceny) > 0)
			wzo_ilosc_ocen_uzupelnij (lista[i].oceny);
		
		if (s_tmp != 0) {
			srednia += s_tmp;
			ilosc++;
		}
		
		ins_str[0] = lista[i].przedmiot;
		ins_str[2] = tmp;
		
		char tmp_txt[512];
		wzo_wstaw_przecinki (tmp_txt, lista[i].oceny);
		ins_str[1] = tmp_txt;
		
		gtk_clist_insert (GTK_CLIST (wzo_lista_ocen), 0, ins_str);
		
		i++;
	}
	
	if ((srednia == 0) | (ilosc == 0))
		sprintf (tmp, _("BRAK"), (srednia / ilosc));
	else
		sprintf (tmp, "%.2f", (srednia / ilosc));
		
	ins_str[0] = "---------------";
	ins_str[1] = _("srednia");
	ins_str[2] = tmp;
	
	gtk_clist_insert (GTK_CLIST (wzo_lista_ocen), i, ins_str);
	gtk_clist_thaw (GTK_CLIST (wzo_lista_ocen));
	
	char tmp_txt [20];
	int  calosc = (wzo_ilosc_ocen[0] + wzo_ilosc_ocen[1] + wzo_ilosc_ocen[2] + wzo_ilosc_ocen[3] + wzo_ilosc_ocen[4] + wzo_ilosc_ocen[5]);
	
	sprintf (tmp_txt, "<b>1: </b> %d (%.0f %%)", wzo_ilosc_ocen[0], oblicz_procent (wzo_ilosc_ocen[0], calosc));
	gtk_label_set_label (GTK_LABEL (wzo_ilosc_1), tmp_txt);
	sprintf (tmp_txt, "<b>2: </b> %d (%.0f %%)", wzo_ilosc_ocen[1], oblicz_procent (wzo_ilosc_ocen[1], calosc));
	gtk_label_set_label (GTK_LABEL (wzo_ilosc_2), tmp_txt);
	sprintf (tmp_txt, "<b>3: </b> %d (%.0f %%)", wzo_ilosc_ocen[2], oblicz_procent (wzo_ilosc_ocen[2], calosc));
	gtk_label_set_label (GTK_LABEL (wzo_ilosc_3), tmp_txt);
	sprintf (tmp_txt, "<b>4: </b> %d (%.0f %%)", wzo_ilosc_ocen[3], oblicz_procent (wzo_ilosc_ocen[3], calosc));
	gtk_label_set_label (GTK_LABEL (wzo_ilosc_4), tmp_txt);
	sprintf (tmp_txt, "<b>5: </b> %d (%.0f %%)", wzo_ilosc_ocen[4], oblicz_procent (wzo_ilosc_ocen[4], calosc));
	gtk_label_set_label (GTK_LABEL (wzo_ilosc_5), tmp_txt);
	sprintf (tmp_txt, "<b>6: </b> %d (%.0f %%)", wzo_ilosc_ocen[5], oblicz_procent (wzo_ilosc_ocen[5], calosc));
	gtk_label_set_label (GTK_LABEL (wzo_ilosc_6), tmp_txt);
	
	sprintf (tmp_txt, _("<b>Wszystkich ocen: </b> %d"), calosc);
	gtk_label_set_label (GTK_LABEL (wzo_ilosc_wszystko), tmp_txt);
}


void wzo_wstaw_przecinki (char tekst[512], char oceny[512])
{
	int i = 0;
	strcpy (tekst, "");
	
	while (i <= strlen (oceny)) {
		sprintf (tekst, "%s%c, ", tekst, oceny[i]);
		
		i++;
	}
}


void wzo_ilosc_ocen_uzupelnij (char tablica[512])
{
	int i = 0;
	while (i != 512) {
		if (isdigit (tablica[i]) > 0) {
			if ((ctoi (tablica[i]) <= 6) && (ctoi (tablica[i]) >= 1))
				wzo_ilosc_ocen [(ctoi (tablica[i]) - 1)]++;
		} else {
			break;
		}
		
		i++;
	}
}
